import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class DOOPLE extends PApplet {

public void setup()
 {smooth();
  strokeWeight(1);
  
  size(1400,880);
  if (frame != null) {
    frame.setResizable(true);
  }
  background(r1,r2,r3);
  thickline();
  alias();
  sampler();
  PFont font;
   font = loadFont("DilleniaUPCBold-48.vlw"); 
   textFont(font);
   fill(r1+Z,r2+Z,r3+Z);
   text("|", width-23, 60);
 }
 
// Original random numbers--they generate colors
float r1 = random(0,205);
float r2 = random(0,205);
float r3 = random(0,205);

// The first point for every sketch
float P = 15;
float V = 5;
float W = 1;
float X = 400;
float Y = 250;
float Z = 50;

float check = 1;

// A graphic representation of the 
// thickness of of "brush" and "eraser"
public void thickline(){
  noStroke();
  ellipseMode(CENTER);
  fill(r1,r2,r3);
  ellipse(width-20,20,28,28);
  fill(r1+Z,r2+Z,r3+Z);
  ellipse(width-20,20,27,27);
  fill(r1,r2,r3);
  ellipse(width-20,20,V,V);
  fill(r1-Z,r2-Z,r3-Z);
  ellipse(width-20,20,W+1,W+1);
}


public void clearbox()
 {
  noStroke();
  fill(r1,r2,r3);
  rect(width-31,39,23,23);
//  strokeWeight(2);
//  stroke(r1+Z,r2+Z,r3+Z);
//  line(width-20,40,width-20,50);
}

public void alias()
{ noStroke();
    fill(r1,r2,r3);
    ellipse(width-20,height-20,30,30);
  fill(r1+50,r2+50,r3+50);
  ellipse(width-20,height-20,27,27);
  stroke(r1,r2,r3);
  strokeWeight(2);
  noFill();
  arc(width-20, height-20, 17, 17, PI, TWO_PI-PI/2);}
  
public void alias2()
{noStroke();
    fill(r1,r2,r3);
    ellipse(width-20,height-20,30,30);
  fill(r1+50,r2+50,r3+50);
  ellipse(width-20,height-20,27,27);
  stroke(r1,r2,r3);
  strokeWeight(2);
  noFill();
  arc(width-20, height-20, 17, 17, 0, PI/2);}
  
 public void sampler()
 {noStroke();
 fill(r1,r2,r3);
 rect(width-31,68,20,23);
 fill(r1-50,r2-50,r3-50);
 rect(width-31,68,9,23);
 fill(r1+50,r2+50,r3+50);
 rect(width-19,68,9,23);
 }

public void fade()
{  noStroke();
fill(r1,r2,r3,6);
   rect(-5,-5,width+5,height+5);}

public void drawline()
 {  float r4 = random(-P,P);
    float r5 = random(-P,P);
    Z = 50;
    stroke(r1+Z,r2+Z,r3+Z);
    strokeWeight(1);
    line(X,Y,(X+r4),(Y+r5));
    X = (r4+X);
    Y = (r5+Y);
// Wraps the lines around the drawing
    if(X<=0){X=width;}if(X>width){X=0;}
    if(Y<=0){Y=height;}if(Y>height){Y=0;}
}

public void draw() 
 { if (keyPressed)
 
// Save the image
 { if (key == 's' || key == 'S') {
   saveFrame("sketch-####.png");
   delay(200);
  }
  
 if (key == 'd' || key == 'D') {
   if (check == 0)
   {
    delay(200);
    smooth();
    check = 1;
    alias();}
    
    else
   {
    delay(200);
    noSmooth();
    check = 0;
    alias2();
    }}
    
// Changes level of random points
   if (key == 'q' || key == 'Q') 
 { P = 25;
   clearbox();
   PFont font;
   font = loadFont("DilleniaUPCBold-48.vlw"); 
   textFont(font);
   fill(r1+Z,r2+Z,r3+Z);
   text("|", width-23, 60);
 }
   if (key == 'w' || key == 'W') 
 { P = 55;
   clearbox();
   PFont font;
   font = loadFont("DilleniaUPCBold-48.vlw"); 
   textFont(font);
   fill(r1+Z,r2+Z,r3+Z);
   text("||", width-26, 60);
 }
   if (key == 'e' || key == 'E') 
 { P = 115;
   clearbox();
   PFont font;
   font = loadFont("DilleniaUPCBold-48.vlw"); 
   textFont(font);
   fill(r1+Z,r2+Z,r3+Z);
   text("|||", width-28, 60); 
 }
    
// 1 - 3 controls line and eraser thickness
  if (key == '1')
   {
   V = 10;
   W = 2;
   thickline();
 }
  if (key == '2')
   {
     V = 15;
     W = 4;
   thickline();
 }
  if (key == '3')
   {
     V = 22;
     W = 15;
   thickline();
 }
   
// Spacebar draws a scribble
  if (key == ' ')
   { 
// If fade() is called, all colors
// will slowly fade to a more natural
// color. Possible option for artists?
     //fade();
   drawline();}
 }
        
  else if(mousePressed && (mouseButton == LEFT))
// Draws with left mouse button
    {
      Z=50;
    stroke(r1-Z,r2-Z,r3-Z);
    strokeWeight(W);
    line(mouseX,mouseY, pmouseX, pmouseY);
  } 
  //Picks up the doodle line
    else if (mousePressed && (mouseButton == CENTER)) {
      
         X = mouseX;
         Y = mouseY;
       }
  //Erases
   else if (mousePressed && (mouseButton == RIGHT)) {
   stroke(r1,r2,r3);
   strokeWeight(V);
   line(mouseX,mouseY, pmouseX, pmouseY);
    }
    
    if (keyPressed == true)
    {
   if (key == 'x') {
   //r1 = random(255);
   //r2 = random(255);
   //r3 = random(255);
   delay(200);
   background(r1,r2,r3);
   sampler();
   thickline();
   clearbox();
   PFont font;
   font = loadFont("DilleniaUPCBold-48.vlw"); 
   textFont(font);
   fill(r1+Z,r2+Z,r3+Z);
   text("|", width-23, 60);
   X = mouseX;
   Y = mouseY;
  }
else if (key == 'r'){
  r1 = random(255);
   r2 = random(255);
   r3 = random(255);
  sampler();
  delay(200);
   
}
}
//  else{  
//strokeWeight(1);}
/*else{
  background(rand1+50,rand2+50,rand3+50);
  imageMode(CENTER);
  PImage b;
// Images must be in the "data" directory to load correctly
b = loadImage("pencilb.png");
image(b, mouseX, mouseY, 20, 20);
 }*/
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "DOOPLE" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
